stages:
  - build
  - test
  - qa
  - qa-prod
  - release
  - deploy

empaquetar:
  stage: build
  tags:
    - mi-runner
  script:
    - mvn package -DskipTests=true
  artifacts:
    paths:
      - target/

pruebas-unitarias:
  stage: build
  tags:
    - mi-runner
  script:
    - mvn test

pruebas-funcionales:
  stage: test
  tags:
    - mi-runner
  dependencies:
    - empaquetar
  script:
    - cp -r target/Baloncesto /usr/local/tomcat/webapps
    - mysql -u root < db/baloncesto.sql
    - export DATABASE_HOST="jdbc:mysql://localhost"
    - export DATABASE_PORT="3306"
    - export DATABASE_NAME="baloncesto"
    - export DATABASE_USER="usuario"
    - export DATABASE_PASS="clave"
    - sh /usr/local/tomcat/bin/catalina.sh stop
    - sh /usr/local/tomcat/bin/catalina.sh start
    - mvn failsafe:integration-test failsafe:verify

calidad-codigo:
  stage: qa
  tags:
    - mi-runner
  script:
    - mvn sonar:sonar -Dsonar.host.url=http://sonarqube:9000 -Dsonar.qualitygate.wait=true -Dsonar.login=admin -Dsonar.password=admin
  allow_failure: true
  rules:
    - if: $CI_COMMIT_BRANCH != 'master'

calidad-codigo-prod:
  stage: qa-prod
  tags:
    - mi-runner
  script:
    - mvn sonar:sonar -Dsonar.host.url=http://sonarqube:9000 -Dsonar.qualitygate.wait=true -Dsonar.login=admin -Dsonar.password=admin
  only:
    - master

despliegue-pre:
  stage: release
  image: docker
  services:
    - docker:dind
  dependencies:
    - empaquetar
  script:
    - docker login registry.gitlab.com -u marcos.ferreras -p $CLAVE
    - docker build -t registry.gitlab.com/marcos.ferreras/baloncesto/baloncesto-pre .
    - docker push registry.gitlab.com/marcos.ferreras/baloncesto/baloncesto-pre
  only:
    - staging

despliegue:
  stage: deploy
  image: docker
  services:
    - docker:dind
  dependencies:
    - empaquetar
    - calidad-codigo-prod
  script:
    - docker login registry.gitlab.com -u marcos.ferreras -p $CLAVE
    - docker build -t registry.gitlab.com/marcos.ferreras/baloncesto .
    - docker push registry.gitlab.com/marcos.ferreras/baloncesto
  when: manual
  only:
    - master
